/*
 ****************************************************
 * Class: Argument                                  *
 * By Arash Partow - 2000                           *
 *                                                  *
 * Comments:                                        *
 * Please read the Common Public License agreement  *
 * before using this piece of code.                 *
 ****************************************************
*/


#ifndef INCLUDE_ARGUMENT_H
#define INCLUDE_ARGUMENT_H


#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string> 
#include <vector>
#include "StringTokenizer.h"

using namespace std;

typedef vector <string> StringList;


class Argument
{

   public:

    Argument();
    Argument(string argtok, int subargcnt, bool comp);
   ~Argument();

    string getArgToken();
    int    getexpfectedSubArgCount();
    int    getSubArgCount();
    string getSubArg(int pos);
    int    getSubArgInt(int pos);
    double getSubArgFloat(int pos);

    bool   addSubArg(string subarg);

    bool   setInitiated();

    bool   isValid();
    bool   isCompulsory();
    bool   isInitiated();

   private:

    bool       initiated;
    bool       compulsory;
    string     argToken;
    int        expfectedSubArgCnt;
    StringList subArg;

};

#endif
