/*
 ****************************************************
 * Class: ArgumentLoader                            *
 * By Arash Partow - 2000                           *
 *                                                  *
 * Comments:                                        *
 * Please read the Common Public License agreement  *
 * before using this piece of code.                 *
 ****************************************************
*/


#ifndef INCLUDE_ARGUMENTLOADER_H
#define INCLUDE_ARGUMENTLOADER_H


#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>
#include <sstream> 
#include <map>
#include "StringTokenizer.h"
#include "Argument.h"

using namespace std;

typedef map <string, Argument> ArgumentMap;
   
class ArgumentLoader
{

   public:

    ArgumentLoader(int argc, char *argv[]);
   ~ArgumentLoader();

    bool     addPattern(string argtok, int subargcnt, bool comp);
    string   getArgumentString();
    int      getArgumentCount();
    Argument getArgument(string argtok);
    
    bool     argumentExists(string argtok);
    bool     parseArguments();
    StringList getErrors();


   private:
    
    ArgumentMap argumentMap;
    string      argumentStr;
    int         argumentCount;
    StringList  errors;

};

#endif
