#ifndef DCP_FILTER_H_
#define DCP_FILTER_H_

#include <iostream>

#include "Array.h"

class DcpFilter
{
public :
	DcpFilter(size_t rows = 0, size_t cols = 0);
    
    const Array<float>& operator[](size_t i) const;
        
    const Array<float>& ABase() const;
    
    const Array<float>& ASub21() const;
    
    const Array<float>& ASub22() const;
    
    const Array<float>& ASub23() const;
    
    const Array<float>& ASub24() const;
    
    const Array<float>& ASub31() const;
    
    const Array<float>& ASub32() const;
    
    const Array<float>& ASub33() const;
    
    const Array<float>& ASub34() const;
    
    const Array<float>& ASub35() const;
    
    const Array<float>& ASub36() const;
    
    const Array<float>& ASub41() const;
    
    const Array<float>& ASub42() const;
    
    const Array<float>& ASub43() const;
    
    const Array<float>& ASub44() const;
    
    const Array<float>& ASub45() const;
    
    const Array<float>& ASub46() const;
    
    const Array<float>& C1Base() const;
    
    const Array<float>& C1Sub21() const;
    
    const Array<float>& C1Sub22() const;
    
    const Array<float>& C1Sub23() const;
    
    const Array<float>& C1Sub24() const;
    
    const Array<float>& C2Base() const;
    
    const Array<float>& C2Sub21() const;
    
    const Array<float>& C2Sub22() const;
    
    const Array<float>& C2Sub23() const;
    
    const Array<float>& C2Sub24() const;
    
private :
    size_t __rows;
    size_t __cols;
    Array<float> __dcp[27];
    
    void __mesa(Array<float>& m, Array<float>& w1, float fc, float lt);
    void __fan(Array<float>& f, Array<float>& teta, float tc, float tw, 
               float td);
    
friend std::ostream& operator<<(std::ostream& os, const DcpFilter& dcp);
};

#endif
