#include <cmath>

#include "InterATresholdBuilder.h"

InterATresholdBuilder::InterATresholdBuilder()
{
}

Array<float>
InterATresholdBuilder::operator()(const Array<float>& in, float a, float b,
                                  float c)
{
    Array<float> out(in.rows(), in.cols());
    
    for (size_t i = 0; i < in.rows(); i++)
    {
        for (size_t j = 0; j < in.cols(); j++)
        {
        	float mij = fabs(in(i, j));
            out(i, j) = (float) ((float) (1.0 + a * mij + 
            	b * mij * mij) / ((float) (1.0 + c * mij)));
        }
    }
    
    return out;
}
