#include <cmath>

#include "InterBTresholdBuilder.h"

InterBTresholdBuilder::InterBTresholdBuilder()
{
}

Array<float> 
InterBTresholdBuilder::operator()(const Array<float>& in, float a, float b, 
                                  float c)
{
    Array<float> out(in.rows(), in.cols());
    
    for (size_t i = 0; i < in.rows(); i++)
    {
        for (size_t j = 0; j < in.cols(); j ++)
        {
            out(i, j) = (float)(a - (b * expf(-(c * fabs(in(i, j))))));
        }
    }
    
    return out;
}
