#include "IntraATresholdBuilder.h"

IntraATresholdBuilder::IntraATresholdBuilder()
{
}

Array<float>
IntraATresholdBuilder::operator()(const Array<float>& in, float slope)
{
    Array<float> out(in.rows(), in.cols());
                     
    int w = 6;
    float q = 0.7;
    float k1 = (float)(powf((float)w, 1.0 - (1.0 / ( 1.0 - q))));
    float k2 = (float)(powf((float)w, 1.0 / (1.0 - q)));
    float bb = 4.0;
    
    for (size_t i = 0; i < in.rows(); i ++)
        for (size_t j = 0; j < in.cols(); j ++)
            out(i, j) = (float)(powf(1.0 + powf(k1 * 
                powf(k2 * fabs(in(i, j)), slope), bb), (1.0 / bb)));
    
    return out;
}
