#include <cmath>

#include "IntraCTresholdBuilder.h"

IntraCTresholdBuilder::IntraCTresholdBuilder()
{
}

Array<float>
IntraCTresholdBuilder::operator()(const Array<float>& in, float a, float b, 
                                    float c)
{
    Array<float> out(in.rows(), in.cols());
    
    for (size_t i = 0;i < in.rows(); i++)
    {
        for (size_t j = 0 ;j < in.cols(); j++)
        {
        	float mij = fabs(in(i, j));
            out(i, j) = (float)((1.0 + a * mij) + 
            	b * powf(mij, 2.0)) / (float) (1.0 + c * mij);
        }
    }
    
    return out;
}
