#ifndef KOMPARATOR_H_
#define KOMPARATOR_H_

#include <iostream>

#include "Array.h"
#include "AccImage.h"
#include "CsfFilter.h"
#include "DcpFilter.h"
#include "Metric.h"

class Komparator
{
public:
	Komparator(const RgbImage& original, float alpha = 1, float beta = 4, 
               float co = 5, float a = 0.000751, float b = 3.8, 
               int maskFlag = 70, bool nobj = false);
    
    Metric operator()(const RgbImage& degraded);

private:

    float __alpha;
    float __beta;
    float __co;
    float __a;
    float __b;
    int __maskFlag;
    bool __nobj;
    
    CsfFilter __csf;
    DcpFilter __dcp;
    
    Array<float> __ndcpor[27];
    Array<int> __eor;
    
    void __decompose(const AccImage& acc, Array<float> ndcp[]);
    Metric __compare(Array<float> dndcp[], Array<int>& edges);

friend std::ostream& operator<<(std::ostream& os, const Komparator& kmp);
};

#endif
