#ifndef KOMPARATOR2_H_
#define KOMPARATOR2_H_

#include <iostream>

#include "Array.h"
#include "AccImage.h"
#include "CsfFilter.h"
#include "DcpFilter.h"
#include "Comparison.h"

class Komparator2
{
public:
	Komparator2(const RgbImage& original, float alpha = 1, float beta = 4, 
               float co = 5, float a = 0.000751, float b = 3.8, 
               bool maskIntraA = false, bool maskInterA = false,
               bool maskIntraC1 = false, bool maskInterC1 = false,
               bool maskIntraC2 = false, bool maskInterC2 = false);
    
    Comparison operator()(const RgbImage& degraded);

private:

    float __alpha;
    float __beta;
    float __co;
    float __a;
    float __b;
    bool __maskIntraA;
    bool __maskInterA;
    bool __maskIntraC1;
    bool __maskInterC1;
    bool __maskIntraC2;
    bool __maskInterC2;
    
    CsfFilter __csf;
    DcpFilter __dcp;
    
    Array<float> __ndcpor[27];
    Array<int> __eor;
    
    void __decompose(const AccImage& acc, Array<float> ndcp[]);
    Comparison __compare(Array<float> dndcp[], Array<int>& edges);
};

#endif
