#include <QtGui>

#include "QKomparatorErrorMapDialog.h"

QKomparatorErrorMapDialog::QKomparatorErrorMapDialog(QString original, QString degraded, Array<float>& err)
{
    ui.setupUi(this);
    
    setWindowTitle(original + " - " + degraded);
    QImage err_image((int)err.cols(), (int)err.rows(), QImage::Format_RGB32);
    int min = err.min() > 0 ? 0 : err.min();
    int max = err.max() - min;
        
    for (int i = 0; i < err.rows(); i++)
        for (int j = 0; j < err.cols(); j++)
        {
            
            int pixel = (0x000000FF & ((int)err((size_t)i, (size_t)j) - min) * 255 / max);
            err_image.setPixel(j, i, qRgb(pixel, pixel, pixel));
        }
    
    ui.label->setPixmap(QPixmap::fromImage(err_image));
}
