#ifndef RGB_IMAGE_H_
#define RGB_IMAGE_H_

#include <string>
#include <iostream>

#include "Array.h"

class RgbImage
{
public:
    RgbImage();
	RgbImage(const std::string fname);
	virtual ~RgbImage();
    
    size_t rows() const;
    size_t cols() const;

    const Array<unsigned int>& R() const;
    const Array<unsigned int>& G() const;
    const Array<unsigned int>& B() const;
    
private:
    size_t __rows;
    size_t __cols;
    
    Array<unsigned int> __R;
    Array<unsigned int> __G;
    Array<unsigned int> __B;
    
friend std::ostream& operator<<(std::ostream& os, const RgbImage& img);
};

#endif
